(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTICQMarquee;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AHMTWavePlayer,AHMClasses,ExtCtrls;

type
  TAHMICQMarquee = class(TAHMWavePlayer)
  private
    FMarquee : TBitmap;
    FTop    : Integer;
    BackgroundBmp : TBitmap;
    FAbout : TAHMAbout;
    procedure SetMarquee(Value: TBitmap);
    procedure createbuffer;
  protected
  public
    constructor Create(AOwner : TComponent); override;
    procedure Loaded; override;
    destructor Destroy; override;
    Function Execute : Boolean; override;
  published
    property About : TAHMAbout read FAbout write FAbout;
    property Marquee : TBitmap read FMarquee write SetMarquee;
    Property Top : Integer read FTop write FTop Default 100;
  end;

implementation

constructor TAHMICQMarquee.Create;
begin
  inherited Create(AOwner);
  FAbout:=TAHMAbout.Create(self);
  FMarquee:=TBitmap.create;
  BackgroundBmp:=TBitmap.create;
  FTop:=100;
end;

procedure TAHMICQMarquee.Loaded;
begin
  inherited Loaded;
  FAbout.Check;
end;

destructor TAHMICQMarquee.Destroy;
begin
  FMarquee.Free;
  BackgroundBmp.Free;
  FAbout.Free;
  inherited Destroy;
end;

procedure TAHMICQMarquee.SetMarquee(Value: TBitmap);
begin
  FMarquee.assign(Value);
end;

procedure TAHMICQMarquee.createbuffer;
var DC,dcCurrentScreen,CurrentScreen   : hdc;
    FLeft,y  : Integer;
begin
  dc := createdc('DISPLAY',Nil,Nil,Nil);
  FLeft:= screen.width;
  y:= screen.height;
  dcCurrentScreen := createcompatibledc(dc);
  CurrentScreen := createcompatiblebitmap(dc,FLeft,y);
  selectobject(dcCurrentScreen,CurrentScreen);
  bitblt(dcCurrentScreen,0,0,FLeft,y,dc,0,0,SRCCOPY);
  bitblt(BackgroundBmp.canvas.handle,0,0,FLeft,FMarquee.height,DCCurrentScreen,0,FTop,SRCCOPY);
  deletedc(dcCurrentScreen);
  deletedc(dc);
end;

Function TAHMICQMarquee.Execute : Boolean;
var acanvas : TCanvas;
    ahandle : thandle;
    FLeft       : Integer;
begin
  result:=false;
  acanvas:=TCanvas.create;
  ahandle:=createdc('DISPLAY',nil,nil,nil);
  acanvas.handle:=ahandle;
  BackgroundBmp.height:=FMarquee.height;
  BackgroundBmp.width:=screen.width;
  try
    createbuffer;
    inherited Execute;
    for FLeft:=Screen.width+FMarquee.width downto -(FMarquee.width) do
    begin
      acanvas.draw(FLeft,FTop,FMarquee);
      acanvas.copyrect(rect(FLeft+FMarquee.width,FTop,FLeft+FMarquee.width+1,FTop+
         FMarquee.height),BackgroundBmp.canvas,rect(FLeft+FMarquee.width,0,
         FLeft+FMarquee.width+1,FMarquee.height));
         application.processmessages;
    end;
    acanvas.free;
    deletedc(ahandle);
    result:=true;
  except
    Application.HandleException(self);
  end;
end;

end.
