unit Comptest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AnalogMeter, Spin, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel3: TPanel;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    cbZones: TCheckBox;
    cbShowFrame: TCheckBox;
    rgAngle: TRadioGroup;
    btnColor: TButton;
    TabSheet2: TTabSheet;
    cbShowTicks: TCheckBox;
    cbShowValue: TCheckBox;
    cbShowScale: TCheckBox;
    Label6: TLabel;
    edPrecision: TSpinEdit;
    Label7: TLabel;
    edDigits: TSpinEdit;
    Label4: TLabel;
    edTickCount: TSpinEdit;
    Label5: TLabel;
    edMax: TSpinEdit;
    btnFont: TButton;
    TabSheet3: TTabSheet;
    Label2: TLabel;
    edLow: TSpinEdit;
    Label1: TLabel;
    edHigh: TSpinEdit;
    cbZoneEvents: TCheckBox;
    btnTickColor: TButton;
    Label8: TLabel;
    edNeedle: TSpinEdit;
    Label9: TLabel;
    edKnob: TSpinEdit;
    Label10: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    btnLowColor: TButton;
    btnHiColor: TButton;
    btnOKcolor: TButton;
    btnPoppy: TButton;
    btnHiFi: TButton;
    btnRedraw: TButton;
    TabSheet4: TTabSheet;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    rgCaptionPos: TRadioGroup;
    edLowZoneValue: TSpinEdit;
    edHighZoneValue: TSpinEdit;
    edCaptionPos: TSpinEdit;
    Label14: TLabel;
    Button1: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure AnalogMeter1FallBelowDanger(Sender: TObject);
    procedure AnalogMeter1FallBelowLow(Sender: TObject);
    procedure AnalogMeter1RiseAboveDanger(Sender: TObject);
    procedure cbShowValueClick(Sender: TObject);
    procedure rgAngleClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure cbZoneEventsClick(Sender: TObject);
    procedure cbShowTicksClick(Sender: TObject);
    procedure cbShowFrameClick(Sender: TObject);
    procedure AnalogMeter1Resize(Sender: TObject);
    procedure AnalogMeter1Change(Sender: TObject);
    procedure edTickCountChange(Sender: TObject);
    procedure edLowChange(Sender: TObject);
    procedure edHighChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure cbShowScaleClick(Sender: TObject);
    procedure edMaxChange(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure edPrecisionChange(Sender: TObject);
    procedure edDigitsChange(Sender: TObject);
    procedure btnTickColorClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure edNeedleChange(Sender: TObject);
    procedure edKnobChange(Sender: TObject);
    procedure cbZonesClick(Sender: TObject);
    procedure btnLowColorClick(Sender: TObject);
    procedure btnHiColorClick(Sender: TObject);
    procedure btnOKcolorClick(Sender: TObject);
    procedure btnPoppyClick(Sender: TObject);
    procedure btnHiFiClick(Sender: TObject);
    procedure btnRedrawClick(Sender: TObject);
    procedure edLowZoneValueChange(Sender: TObject);
    procedure edHighZoneValueChange(Sender: TObject);
    procedure rgCaptionPosClick(Sender: TObject);
    procedure edCaptionPosChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    AnalogMeter1: TAnalogMeter;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  AnalogMeter1 := TAnalogMeter.Create(Self);
  with AnalogMeter1 do begin
    Parent := Form1;
    Align := alClient; //allows testing resize
    Max := 65535; //Max(Word)
    AngularRange := 270;
    ShowTicksScale := True;
    onChange        := AnalogMeter1Change;
    onRiseAboveHigh := AnalogMeter1RiseAboveDanger;
    onFallBelowHigh := AnalogMeter1FallBelowDanger;
    onRiseAboveLow  := AnalogMeter1FallBelowDanger;
    onFallBelowLow  := AnalogMeter1FallBelowLow;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  AnalogMeter1.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  TrackBar1.Max := Round(AnalogMeter1.Max);
  Edit1Change(Self); //set caption of AnalogMeter
end;

procedure TForm1.AnalogMeter1FallBelowDanger(Sender: TObject);
begin
  Memo1.Lines.Add('Back in Normal');
end;

procedure TForm1.AnalogMeter1FallBelowLow(Sender: TObject);
begin
  Memo1.Lines.Add('LOW!');
end;

procedure TForm1.AnalogMeter1RiseAboveDanger(Sender: TObject);
begin
  Memo1.Lines.Add('HIGH!');
end;

procedure TForm1.cbShowValueClick(Sender: TObject);
begin
  AnalogMeter1.ShowValue := cbShowValue.Checked;
end;

procedure TForm1.rgAngleClick(Sender: TObject);
begin
  case rgAngle.ItemIndex of
    0 : AnalogMeter1.AngularRange := 90;
    1 : AnalogMeter1.AngularRange := 180;
    2 : AnalogMeter1.AngularRange := 270;
    3 : AnalogMeter1.AngularRange := 360;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  AnalogMeter1.Value := TrackBar1.Position;
end;

procedure TForm1.cbZoneEventsClick(Sender: TObject);
begin
  AnalogMeter1.EnableZoneEvents := cbZoneEvents.Checked;
end;

procedure TForm1.cbShowTicksClick(Sender: TObject);
begin
  AnalogMeter1.ShowTicks := cbShowTicks.Checked;
end;

procedure TForm1.cbShowScaleClick(Sender: TObject);
begin
  AnalogMeter1.ShowTicksScale := cbShowScale.Checked;
end;

procedure TForm1.cbShowFrameClick(Sender: TObject);
begin
  AnalogMeter1.ShowFrame := cbShowFrame.Checked;
end;

procedure TForm1.AnalogMeter1Resize(Sender: TObject);
begin
  memo1.Lines.Add('resized');
end;

procedure TForm1.AnalogMeter1Change(Sender: TObject);
begin
  Label3.Caption := floatToStr(AnalogMeter1.Value);
end;

procedure TForm1.edTickCountChange(Sender: TObject);
begin
  AnalogMeter1.TickCount := edTickCount.Value;
end;

procedure TForm1.edLowChange(Sender: TObject);
begin
  AnalogMeter1.LowZone := edLow.Value;
end;

procedure TForm1.edHighChange(Sender: TObject);
begin
  AnalogMeter1.HighZone := edHigh.Value;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  AnalogMeter1.Caption := Edit1.Text;
end;
                                               
procedure TForm1.btnFontClick(Sender: TObject);
begin
  If not FontDialog1.Execute then Exit;
  AnalogMeter1.Font := FontDialog1.Font;
end;

procedure TForm1.edMaxChange(Sender: TObject);
begin
  AnalogMeter1.Max := edMax.Value;
  TrackBar1.Max := edMax.Value;
end;

procedure TForm1.btnColorClick(Sender: TObject);
begin
  If not ColorDialog1.Execute then Exit;
  AnalogMeter1.Color := ColorDialog1.Color;
end;

procedure TForm1.edPrecisionChange(Sender: TObject);
begin
  AnalogMeter1.TickPrecision := edPrecision.Value;
  AnalogMeter1.ValuePrecision := edPrecision.Value;
end;

procedure TForm1.edDigitsChange(Sender: TObject);
begin
  AnalogMeter1.TickDigits := edDigits.Value;
  AnalogMeter1.ValueDigits := edDigits.Value;
end;

procedure TForm1.btnTickColorClick(Sender: TObject);
begin
  If not ColorDialog1.Execute then Exit;
  AnalogMeter1.TickColor := ColorDialog1.Color;
end;

procedure TForm1.Button1Click(Sender: TObject);
var F : TForm;
begin
  F := TForm.Create(Self);
  F.Show;
  AnalogMeter1.PaintTo(F.Canvas.Handle, 0, 0);
  Sleep(1000);
  F.Free;
end;

procedure TForm1.edNeedleChange(Sender: TObject);
begin
  AnalogMeter1.NeedleWidth := edNeedle.Value;
end;

procedure TForm1.edKnobChange(Sender: TObject);
begin
  AnalogMeter1.KnobSize := edKnob.Value;
end;

procedure TForm1.cbZonesClick(Sender: TObject);
begin
  AnalogMeter1.ShowZones := cbZones.Checked;
end;

procedure TForm1.btnLowColorClick(Sender: TObject);
begin
  If not ColorDialog1.Execute then Exit;
  AnalogMeter1.LowZoneColor := ColorDialog1.Color;
end;

procedure TForm1.btnHiColorClick(Sender: TObject);
begin
  If not ColorDialog1.Execute then Exit;
  AnalogMeter1.HighZoneColor := ColorDialog1.Color;
end;

procedure TForm1.btnOKcolorClick(Sender: TObject);
begin
  If not ColorDialog1.Execute then Exit;
  AnalogMeter1.OKZoneColor := ColorDialog1.Color;
end;

procedure TForm1.btnPoppyClick(Sender: TObject);
begin
  with AnalogMeter1 do begin
    Color := clLime;
    OKZoneColor := clBlue;
    LowZoneColor := clBlack;
    HighZoneColor := clRed;
    TickColor := clYellow;
    AngularRange := 360;
    ShowZones := True;
    NeedleWidth := 30;
    KnobSize := 15;
    Caption := 'Poppy';
    ShowValue := False;
    ShowTicks := False;
    ShowTicksScale := False;
    LowZone := 30;
    HighZone := 70;
  end;
end;

procedure TForm1.btnHiFiClick(Sender: TObject);
begin
  with AnalogMeter1 do begin
    OKZoneColor := clWhite;
    LowZoneColor := clWhite;
    HighZoneColor := clWhite;
    TickColor := clWhite;
    AngularRange := 180;
    ShowZones := False;
    NeedleWidth := 1;
    KnobSize := 4;
    Caption := 'HiFi';
    ShowValue := False;
    ShowTicks := True;
    ShowTicksScale := False;
    LowZone := 0;
    HighZone := 100;
    TickCount := 27;
    Color := clBlack;
  end;
end;

procedure TForm1.btnRedrawClick(Sender: TObject);
begin
  AnalogMeter1.ForceRedraw;
end;

procedure TForm1.edLowZoneValueChange(Sender: TObject);
begin
  AnalogMeter1.LowZoneValue := edLowZoneValue.Value;
end;

procedure TForm1.edHighZoneValueChange(Sender: TObject);
begin
  AnalogMeter1.HighZoneValue := edHighZoneValue.Value;
end;

procedure TForm1.rgCaptionPosClick(Sender: TObject);
begin
  If rgCaptionPos.ItemIndex = 0
    then AnalogMeter1.CaptionPosition := cpTop
    else AnalogMeter1.CaptionPosition := cpBottom;
end;

procedure TForm1.edCaptionPosChange(Sender: TObject);
begin
  AnalogMeter1.CaptionVertAdj := edCaptionPos.Value;
end;

end.
