{ ********************************************************  }
{                                                           }
{ WIdent Editor Expert for Delphi 5.0 (and maybe higher)    }
{ (c) 2001 by Max Vlasov (max_vlasov@yahoo.com)             }
{ Last modified: 28 feb. 2001                               }
{ Fixes 						    }
{                                                           }
{ ********************************************************  }

unit WidentOTA50;

interface uses Classes, ToolsApi;

type
  TWidentBinding = class(TNotifierObject, IOTAKeyboardBinding)
  private
    fLastIdent: string;
    procedure KeyProc(const AContext: IOTAKeyContext; KeyCode: TShortcut;
      var BindingResult: TKeyBindingResult);
  protected
    function  GetBindingType: TBindingType;
    function  GetDisplayName: string;
    function  GetName: string;
    procedure BindKeyboard(const BindingServices: IOTAKeyBindingServices);
  end;

procedure Register;

implementation uses Dialogs, Windows, Menus, SysUtils, WIdentUtils, WIdentOTAUtils;

{ TWidentBinding }

procedure TWidentBinding.BindKeyboard(
  const BindingServices: IOTAKeyBindingServices);

  function AddBinding(Key: Word): boolean;
  begin
    Result:=BindingServices.AddKeyBinding(
      [ShortCut(Key, [ssCtrl, ssAlt])],
      KeyProc, pointer(Key), 0, '', '');
  end;

begin
  AddBinding(VK_UP);
  AddBinding(VK_DOWN);
  AddBinding(VK_LEFT);
  AddBinding(VK_RIGHT);
end;

function TWidentBinding.GetBindingType: TBindingType;
begin
  Result:=btPartial;
end;

function TWidentBinding.GetDisplayName: string;
begin
  Result:='WIdent /CTRL-ALT-(Arrows)/';
end;

function TWidentBinding.GetName: string;
begin
  Result:='Maksee.Wident.1';
end;

procedure TWidentBinding.KeyProc(const AContext: IOTAKeyContext;
  KeyCode: TShortcut; var BindingResult: TKeyBindingResult);
var
  Source, IdentAtCursor: string;
  CursorPosition, CursorLine, CursorCharIndex, Key, FoundPos: integer;
  Previous: boolean;
  Len: integer;
  OK: boolean;
begin
  Source:=OTUGetCurrentSource(CursorPosition, CursorLine, CursorCharIndex);
  if CursorPosition<>0 then
  begin
    Key:=Integer(AContext.Context);
    Ok:=false;

    if (Key = VK_UP) or (Key = VK_LEFT) then
      Previous:=true
    else
      Previous:=false;

    case Key of
      VK_UP, VK_DOWN:
        begin
          Ok:=FindIdentAtPos(Source, CursorPosition, Previous, FoundPos, Len, IdentAtCursor);
          if OK then
            fLastIdent:=IdentAtCursor;
        end;
      VK_LEFT, VK_RIGHT:
        if fLastIdent<>'' then
        begin
          Ok:=FindTextIdent(fLastIdent, Source,
            CursorPosition, Previous, FoundPos);
        end;
    end;
    if Ok then
    begin
      OTUSetCurrentSourcePosition(Source, FoundPos);
    end else
      MessageBeep($FFFFFFFF);
      
    BindingResult:=krHandled;
  end else
    BindingResult:=krUnhandled;
end;

procedure Register;
begin
  (BorlandIDEServices as IOTAKeyboardServices).AddKeyboardBinding(TWidentBinding.Create);
end;

end.

