unit uDBBuilderMain;

{
 Rodolfo d'Ettorre
 rodolfo@viper.net.au
 members.tripod.com/~rodolfo_3
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ExtCtrls, RxRichEd, uScriptParser, RXCtrls,
  iniFiles;

type
  TfrmDBBuilder = class(TForm)
    PanelConfiguracion: TPanel;
    RadioGroupDaoVersion: TRadioGroup;
    GroupBoxPreferences: TGroupBox;
    CheckBoxModifyFields: TCheckBox;
    CheckBoxModifyIndexes: TCheckBox;
    GroupBox1: TGroupBox;
    FilenameAccess: TFilenameEdit;
    GroupBoxScript: TGroupBox;
    FilenameEditScript: TFilenameEdit;
    ButtonValidate: TButton;
    TextListBox1: TTextListBox;
    procedure ButtonValidateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    procedure AddLineToLog(ALine : string);
  public
    { Public declarations }
  end;

var
  frmDBBuilder: TfrmDBBuilder;

implementation

{$R *.DFM}

procedure TfrmDBBuilder.ButtonValidateClick(Sender: TObject);
var
  ATableProcessor : TTableProcessor;
  sVer : string;
begin
  TextListBox1.Items.Clear;
  {if not Fileexists(FilenameAccess.FileName) then
  begin
    MessageDlg('File ' + FilenameAccess.FileName + ' not found', mtError, [mbOk], 0);
    exit;
  end; }
  if not Fileexists(FilenameEditScript.FileName) then
  begin
    MessageDlg('File ' + FilenameEditScript.FileName + ' not found', mtError, [mbOk], 0);
    exit;
  end;
  sVer := '36';
  if RadioGroupDaoVersion.ItemIndex = 0 then
    sVer := '35';
  ATableProcessor := TTableProcessor.create(FilenameAccess.FileName, FilenameEditScript.FileName, sVer);
  ATableProcessor.ModifyFields := CheckBoxModifyFields.Checked;
  ATableProcessor.OnLogMessage := AddLineToLog;
  ATableProcessor.ProcessFiles;
  //TextListBox1.items.Assign(ATableProcessor.TableList);
end;

procedure TfrmDBBuilder.FormCreate(Sender: TObject);
var
  AnIni : TIniFile;
begin
  AnIni := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    FilenameAccess.FileName := AnIni.ReadString('Files', 'DatabaseFile', '');
    FilenameEditScript.FileName := AnIni.ReadString('Files', 'ScriptFile', '');
    RadioGroupDaoVersion.ItemIndex := AnIni.ReadInteger('Dao', 'DaoVersion', 0);
  finally
    AnIni.Free;
  end;
end;


procedure TfrmDBBuilder.FormDestroy(Sender: TObject);
var
  AnIni : TIniFile;
begin
  AnIni := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    AnIni.WriteString('Files', 'DatabaseFile', FilenameAccess.FileName);
    AnIni.WriteString('Files', 'ScriptFile', FilenameEditScript.FileName);
    AnIni.WriteInteger('Dao', 'DaoVersion', RadioGroupDaoVersion.ItemIndex);
  finally
    AnIni.Free;
  end;
end;

procedure TfrmDBBuilder.AddLineToLog(ALine : string);
begin
  TextListBox1.Items.Add(Aline);
  Application.ProcessMessages;
end;


end.
