unit uMain;
{
 Rodolfo d'Ettorre
 rodolfo@viper.net.au
 members.tripod.com/~rodolfo_3
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ComObj, ExtCtrls, RxRichEd, ComCtrls, IniFiles;

type
  TfrmMain = class(TForm)
    PanelDatabasePath: TPanel;
    Label1: TLabel;
    FilenameAccess: TFilenameEdit;
    Button1: TButton;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    PanelTableList: TPanel;
    Splitter2: TSplitter;
    PanelTableStruct: TPanel;
    PanelTableListTitle: TPanel;
    PanelTableStructTitle: TPanel;
    ListBoxTables: TListBox;
    RxRichEditFields: TRxRichEdit;
    PanelButtons: TPanel;
    ButtonProcessList: TButton;
    ButtonSave: TButton;
    ButtonSelectAll: TButton;
    SaveDialog1: TSaveDialog;
    RxRichEditDictionary: TRxRichEdit;
    RadioGroupDao: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure ListBoxTablesClick(Sender: TObject);
    procedure ButtonProcessListClick(Sender: TObject);
    procedure ButtonSelectAllClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FAccess : Variant;
    FDatabase : Variant;
    procedure ProcessTable(ATableName : string);
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.Button1Click(Sender: TObject);
var
  i : integer;
begin
  if RadioGroupDao.ItemIndex = 1 then
    FAccess := CreateOleObject('Dao.DBEngine.36')
  else
    FAccess := CreateOleObject('Dao.DBEngine.35');
  FDatabase := FAccess.Opendatabase(FilenameAccess.FileName);
  ListBoxTables.Items.Clear;
  for i := 0 to FDatabase.TableDefs.Count - 1 do
  begin
    if Pos('MSYS', UpperCase(FDatabase.TableDefs[i].Name)) <> 1 then
      ListBoxTables.Items.Add(FDatabase.TableDefs[i].Name);
  end;

end;

procedure TfrmMain.ListBoxTablesClick(Sender: TObject);
var
  ATable, AField, AnIndex : Variant;
  i, j : integer;
  sAuxStr : string;
begin
  RxRichEditFields.Lines.Clear;
  RxRichEditFields.Lines.Add('Table: ' + ListBoxTables.Items.Strings[ListBoxTables.ItemIndex]);
  RxRichEditFields.Lines.Add(Format('  %-25s %-10s %-10S %-15s %-20S %-10s %-17S',['Fields','Type', 'Size','Required',
    'Allow Zero Length', 'Attributes', 'Default Value']));
  ATable := FDatabase.TableDefs[ListBoxTables.Items.Strings[ListBoxTables.ItemIndex]];
  for i := 0 to Atable.Fields.Count - 1 do
  begin
    AField := ATable.Fields[i];
    RxRichEditFields.Lines.Add(Format('  %-25s %-10s %-10S %-15s %-20S %-10s %-17S',
      [ATable.Fields[i].Name, IntToStr(Integer(AField.Type)), IntToStr(Integer(AField.Size)),
      IntToStr(Integer(AField.Required)), IntToStr(Integer(AField.AllowZeroLength)),
      IntToStr(Integer(AField.Attributes)), String(AField.DefaultValue)]));
  end;
  RxRichEditFields.Lines.Add('  Indexes:');
  for i := 0 to ATable.Indexes.count - 1 do
  begin
    AnIndex := ATable.Indexes[i];
    sAuxStr := AnIndex.Name;
    if AnIndex.Primary then
      sAuxStr := sAuxStr + '  Primary key';
    if AnIndex.Unique then
      sAuxStr := sAuxStr + '  Unique';
    if AnIndex.Required then
      sAuxStr := sAuxStr + ' Required';
    RxRichEditFields.Lines.Add('    ' + sAuxStr);
    for j := 0 to  AnIndex.Fields.Count - 1 do
    begin
      RxRichEditFields.Lines.Add('      ' + AnIndex.Fields[j].Name);
    end;  
  end;

end;

procedure TfrmMain.ButtonProcessListClick(Sender: TObject);
var
  i : integer;
begin
  if ListBoxTables.SelCount = 0 then
    exit;
  RxRichEditDictionary.Lines.clear;
  RxRichEditDictionary.Lines.Add('Database name: ' +  ExtractFilename(FilenameAccess.FileName));
  for i := 0 to ListBoxTables.Items.Count - 1 do
  begin
    if not ListBoxTables.Selected[i] then
      continue;
    ProcessTable(ListBoxTables.Items[i]);
  end;
end;

procedure TfrmMain.ProcessTable(ATableName : string);
var
  ATable, AField, AnIndex : Variant;
  i, j : integer;
  sAuxStr : string;
begin
  if ATableName = '' then
    exit;
  RxRichEditDictionary.Lines.Add('Table: ' + ATableName);
  RxRichEditDictionary.Lines.Add(Format('  %-25s %-10s %-10S %-15s %-20S %-10s %-17S',['Fields','Type', 'Size','Required',
    'Allow Zero Length', 'Attributes', 'Default Value']));
  ATable := FDatabase.TableDefs[ATableName];
  for i := 0 to Atable.Fields.Count - 1 do
  begin
    AField := ATable.Fields[i];
    RxRichEditDictionary.Lines.Add(Format('  %-25s %-10s %-10S %-15s %-20S %-10s %-17S',
      [ATable.Fields[i].Name, IntToStr(Integer(AField.Type)), IntToStr(Integer(AField.Size)),
      IntToStr(Integer(AField.Required)), IntToStr(Integer(AField.AllowZeroLength)),
      IntToStr(Integer(AField.Attributes)), String(AField.DefaultValue)]));
  end;
  RxRichEditDictionary.Lines.Add('  Indexes:');
  for i := 0 to ATable.Indexes.count - 1 do
  begin
    AnIndex := ATable.Indexes[i];
    sAuxStr := 'I: ' + AnIndex.Name;
    if AnIndex.Primary then
      sAuxStr := sAuxStr + '  Primary Key';
    if AnIndex.Unique then
      sAuxStr := sAuxStr + '  Unique';
    if AnIndex.Required then
      sAuxStr := sAuxStr + ' Required';
    RxRichEditDictionary.Lines.Add('    ' + sAuxStr);
    for j := 0 to  AnIndex.Fields.Count - 1 do
    begin
      RxRichEditDictionary.Lines.Add('      ' + AnIndex.Fields[j].Name);
    end;  
  end;
  RxRichEditDictionary.Lines.Add('-----');

end;


procedure TfrmMain.ButtonSelectAllClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to ListBoxTables.Items.Count - 1 do
    ListBoxTables.selected[i] := True;
end;

procedure TfrmMain.ButtonSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    RxRichEditDictionary.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  AnIni : TIniFile;
begin
  AnIni := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  RadioGroupDao.ItemIndex := AnIni.ReadInteger('System', 'DaoVersion', 0);
  FilenameAccess.FileName := AnIni.ReadString('System', 'Filename', '');
  AnIni.Free;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
  AnIni : TIniFile;
begin
  AnIni := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  AnIni.WriteInteger('System', 'DaoVersion', RadioGroupDao.ItemIndex);
  AnIni.WriteString('System', 'Filename', FilenameAccess.FileName);
  AnIni.Free;
end;

end.
