unit WABD_Response;

interface

uses Classes,WABD_Cookies;

type
  TWABD_CustomResponse = class
  protected
     FStatus:integer;
     FContentType:string;
     FContentDesc:string;
     FLocation:string;
     FHeader:TStringList;
     FResponse:TStringList;
     FCookies:TWABD_Cookies;
     FOverrideStandardResponse:boolean;

     function FormatResponse:string; virtual; abstract;
  public
     constructor Create;
     destructor Destroy; override;

     property Status:integer read FStatus write FStatus;
     property ContentType:string read FContentType write FContentType;
     property ContentDesc:string read FContentDesc write FContentDesc;
     property Location:string read FLocation write FLocation;
     property Header:TStringList read FHeader write FHeader;
     property OverrideStandardResponse:boolean read FOverrideStandardResponse write FOverrideStandardResponse;
     property Response:TStringList read FResponse;
     property Cookies:TWABD_Cookies read FCookies;
  end;

implementation

constructor TWABD_CustomResponse.Create;
begin
     inherited;
     FCookies:=TWABD_Cookies.Create(TWABD_Cookie);
     FResponse:=TStringList.Create;
     FHeader:=TStringList.Create;
end;

destructor TWABD_CustomResponse.Destroy;
begin
     FCookies.Free;
     FResponse.Free;
     FHeader.Free;
     inherited;
end;

end.
