{ ****************************************************************** }
{                                                                    }
{   VCL component TINIlist                                           }
{                                                                    }
{   A listbox that work like the INI style.                          }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\program files\borland\components\inilistbox\inilist.cd }
{   on 16 Jan 2001 at 1:10                                           }
{                                                                    }
{   A Freewere component by Peter Giroux                             }
{                                                                    }
{   A Component (ListBox) that acts like an INI File                 }
{ ****************************************************************** }

unit INIlist;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Stdctrls;

type
  TINIlist = class(TListBox)
    private
      { Private fields of TINIlist }
        { Storage for property Changed }
        FChanged : Boolean;
        { Storage for property Data }
        FData : String;
        { Storage for property Header }
        FHeader : String;
        { Storage for property HeaderLine }
        FHeaderLine : Integer;
        { Storage for property Title }
        FTitle : String;
        DataList : TStringList;
        Headerlist : TStringList;

      { Private methods of TINIlist }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        { Read method for property Data }
        function GetData : String;
        { Read method for property Header }
        function GetHeader : String;
        { Write method for property Header }
        procedure SetHeader(Value : String);
        { Read method for property Title }
        function GetTitle : String;
        { Write method for property Title }
        procedure SetTitle(Value : String);
        function FindBottom(Section:String):Integer;
        { To find the data title... }
        function FindData (Section:string;Data:string):Integer;
        { To find the section... }
        function FindSection (Section:String):Integer;
        { To fing the nex section... }
        function NextSect (Section:string):integer;

    protected
      { Protected fields of TINIlist }

      { Protected methods of TINIlist }
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;

    public
      { Public fields and properties of TINIlist }
        property Data : String read GetData;

      { Public methods of TINIlist }
        procedure AddHeader(Section:String);
        constructor Create(AOwner: TComponent); override;
        procedure DeleteData(Section:String;Data:String);
        procedure DeleteSection(Section:String);
        procedure DeleteSectionData(Section:String);
        destructor Destroy; override;
        function FindHeader(Header:String):Integer;
        function GetBoolean (Section:String;Data:string;Default:Boolean):Boolean;
        function GetColor (Section:String;Data:string;Default:TColor):TColor;
        function GetDouble (Section:String;Data:string;Default:Double):Double;
        { Gets a Integer from the INI ListBox... }
        function GetInteger (Section:String;Data:string;Default:Integer):Integer;
        { Gets a String from the INI ListBox... }
        function GetString (Section:String;Data:String;Default:String):String;
        procedure PutBoolean (Section:String;Data:string;Default:Boolean);
        procedure PutColor (Section:String;Data:string;Default:TColor);
        procedure PutDouble (Section:String;Data:string;Default:Double);
        { Puts a Integer in the INI List Box... }
        procedure PutInteger (Section:String;Data:String;Default:Integer);
        { Puts a String in the INI List Box... }
        procedure PutString (Section:String;Data:string;Default:String);
        procedure ReadData;
        procedure WriteData(Data:String);

    published
      { Published properties of TINIlist }
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnEnter;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property Changed : Boolean read FChanged write FChanged default False;
        property Header : String read GetHeader write SetHeader;
        property HeaderLine : Integer read FHeaderLine write FHeaderLine;
        property Title : String read GetTitle write SetTitle;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TINIlist with PGC as its
       default page on the Delphi component palette }
     RegisterComponents('PGC', [TINIlist]);
end;

{ Method to set variable and property values and create objects }
procedure TINIlist.AutoInitialize;
begin
     DataList := TStringList.Create;
     Headerlist := TStringList.Create;
     FChanged := False;
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TINIlist.AutoDestroy;
begin
     DataList.Free;
     Headerlist.Free;
end; { of AutoDestroy }

{ Read method for property Data }
function TINIlist.GetData : String;
begin
     Result := FData;
end;

{ Read method for property Header }
function TINIlist.GetHeader : String;
begin
     Result := FHeader;
     //HeaderLine:=
end;

{ Write method for property Header }
procedure TINIlist.SetHeader(Value : String);
begin
     FHeader := Value;
end;

{ Read method for property Title }
function TINIlist.GetTitle : String;
begin
     Result := FTitle;
end;

{ Write method for property Title }
procedure TINIlist.SetTitle(Value : String);
begin
     FTitle := Value;
end;

{ Override OnClick handler from TListBox }
procedure TINIlist.Click;
begin
     { Code to execute before activating click
       behavior of component's parent class }

     { Activate click behavior of parent }
     inherited Click;

     { Code to execute after click behavior
       of parent }

end;

{ Override OnKeyPress handler from TListBox }
procedure TINIlist.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     { Key contains the character produced by the keypress.
       It can be tested or assigned a new value before the
       call to the inherited KeyPress method.  Setting Key
       to #0 before call to the inherited KeyPress method
       terminates any further processing of the character. }

     { Activate KeyPress behavior of parent }
     inherited KeyPress(Key);

     { Code to execute after KeyPress behavior of parent }

end;

procedure TINIlist.AddHeader(Section:String);
     { Internal declarations for method }
     { type }
     { . . . }
     { var }
     { . . . }
begin
//
end;

constructor TINIlist.Create(AOwner: TComponent);
begin
     { Call the Create method of the parent class }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables and      }
     { properties; also, it creates objects for properties of       }
     { standard Delphi object types (e.g., TFont, TTimer,           }
     { TPicture) and for any variables marked as objects.           }
     { AutoInitialize method is generated by Component Create.      }
     AutoInitialize;

     { Code to perform other tasks when the component is created }

end;

procedure TINIlist.DeleteData(Section:String;Data:String);
     { Internal declarations for method }
     { type }
     { . . . }
      var
      x:integer;
begin
if items.count-1>-1 then
   begin
   x:=FindData(Section,Data); // Looks for the Title then the Section
   if x>-1 then Items.delete(x); //Deletes the Item
   end;
end;

procedure TINIlist.DeleteSection(Section:String);
      var
     x,y,z:integer;
begin
if items.count-1>-1 then
begin
     x:=findsection(section); //Finds teh section
     if x>-1 then
     begin
          y:=NextSect(Section); // Finds the next section
          y:=y-x;
          for z:=0 to y do
          begin
               items.delete(x); //Delets the Item in the list
          end;
               refresh; // Refreash the list

     end;
end;
end;

procedure TINIlist.DeleteSectionData(Section:String);
     { Internal declarations for method }
     { type }
     { . . . }
      var
     x,y,z:integer;
begin
//MessageDlg('This Option is not Active...', mtInformation, [mbOK], 0);
if items.count-1>-1 then
begin
     x:=findsection(section);
     if x>-1 then
     begin
          Inc(x);
          y:=NextSect(Section);
          y:=y-x;
         for z:=1 to y do
          begin
               items.delete(x);
          end;
               refresh;

     end;
end;
end;

destructor TINIlist.Destroy;
begin
     { AutoDestroy, which is generated by Component Create, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

function TINIlist.FindBottom(Section:String):Integer;
     var
     x,y:integer;
begin
x:=findSection(section);
result:=-1;
if x>-1 then
  for y:=x+1 to items.count-1 do
  begin
  if trim(items[y])='' then
  begin
  result:=y;
  Break;
  end;

  if y=items.count-1 then result:=items.count-1;
  end;

end;

{ To find the data title... }
function TINIlist.FindData (Section:string;Data:string):Integer;
      var
      x,y,Defult:integer;
begin
x:=findSection(Section);
data:=data+'=';
defult:=-1;
Result:=defult;
if (x>=0) and (items.count-1>x+1) then
 for y:=x+1 to items.count-1 do
 begin
      if Pos(Uppercase(data),Uppercase(items[y]))=1 then
       begin
        result:=y;
        Break;
       end;

       if (pos('[',Items[y])=1) then
        begin
         result:=defult;
         Break;
        end;
 end;
end;

function TINIlist.FindHeader(Header:String):Integer;
     { var }
     { . . . }
begin
//
end;

{ To find the section... }
function TINIlist.FindSection (Section:String):Integer;
      var
     x,y:integer;
begin
x:=items.count-1;
Result:=-1;
if x>-1 then
 for y:=0 to x do
   if CompareStr(uppercase('['+section+']'),uppercase(items[y]))= 0 then   begin
   Result:=y;
   Break;
   end;

end;

function TINIlist.GetBoolean (Section:String;Data:string;Default:Boolean):Boolean;
var
x:integer;
y:Boolean;
strin: string;

begin
x:=finddata(Section,Data);
if x>-1 then
begin
strin:=copy(items[x],Pos('=',items[x])+1,length(items[x]));
  y:=Default;
  if lowercase(strin)='true' then y:=true;
  if lowercase(strin)='false' then y:=False;
  Result:=y;
end
else
result:=Default;

end;

function TINIlist.GetColor (Section:String;Data:string;Default:TColor):TColor;
var
x:integer;
begin
x:=finddata(Section,Data);
if x>-1 then
result:=StringToColor(copy(items[x],Pos('=',items[x])+1,length(items[x])))
else
result:=Default;

end;

function TINIlist.GetDouble (Section:String;Data:string;Default:Double):Double;
var
x:integer;
y:double;
strin: string;

begin
x:=finddata(Section,Data);
if x>-1 then
begin
strin:=copy(items[x],Pos('=',items[x])+1,length(items[x]));
  try
  y:=StrToFloat(strin);
  except
    on EConvertError do y:=Default;
  end;
Result:=y;
end
else
result:=Default;

end;

{ Gets a Integer from the INI ListBox... }
function TINIlist.GetInteger (Section:String;Data:string;Default:Integer):Integer;
var
x,y:integer;
strin: string;

begin
x:=finddata(Section,Data);
if x>-1 then
begin
strin:=copy(items[x],Pos('=',items[x])+1,length(items[x]));
  try
  y:=StrToInt(strin);
  except
    on EConvertError do y:=Default;
  end;
Result:=y;
end
else
result:=Default;

end;

{ Gets a String from the INI ListBox... }
function TINIlist.GetString (Section:String;Data:String;Default:String):String;
var
x:integer;
begin
x:=finddata(Section,Data);
if x>-1 then
result:=copy(items[x],Pos('=',items[x])+1,length(items[x]))
else
result:=Default;

end;

procedure TINIlist.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

{ To fing the nex section... }
function TINIlist.NextSect (Section:string):integer;
      var
     x,y:integer;
begin
x:=findSection(section);
result:=-1;
if x>-1 then
  for y:=x+1 to items.count-1 do
  begin
  if pos('[',items[y])=1 then begin
  result:=y;
  Break;
  end;

  if y=items.count-1 then result:=items.count-1;
  end;

end;

procedure TINIlist.PutBoolean (Section:String;Data:string;Default:Boolean);
var
     w,x,y:integer;
begin
x:=findSection(section);
if x=-1 then
  begin
  items.add('['+section+']');
  items.add('');
  update;
  //x:=FindSection(section);
  end;
w:=FindBottom(section);
y:=finddata(section,data);
if y=-1 then
  if w-1 < Items.count-1 then
     if default=true then
        begin
        Items.insert(w,data+'=True');
        refresh;
        end
     else
        begin
        Items.insert(w,Data+'=False');
        refresh;
        end
  Else
     if default=true then
        Begin
        Items.insert(w,data+'=True');
        refresh;
        End
     else
        begin
        Items.insert(w,Data+'=False');
        refresh;
        end

else
    If default=True then
       begin
       Items[y]:=data+'=True';
       refresh;
       end
    Else
       begin
       Items[y]:=data+'=False';
       refresh;
       end;
end;

procedure TINIlist.PutColor (Section:String;Data:string;Default:TColor);
var
     w,x,y:integer;
begin
x:=findSection(section);
if x=-1 then
  begin
  items.add('['+section+']');
  items.add('');
  update;
 // x:=FindSection(section);
  end;
w:=FindBottom(section);
y:=finddata(section,data);
if y=-1 then
  if w-1 < Items.count-1 then
  begin
  Items.insert(w,data+'=$'+IntToHex(ColorToRGB(Default),6));
  refresh;
  end
  else
  begin
  Items.Add(data+'=$'+IntToHex(ColorToRGB(Default),6));
  refresh;
  end
else
  begin
  Items[y]:=data+'=$'+IntToHex(ColorToRGB(Default),6);
  refresh;
  end;
end;

procedure TINIlist.PutDouble (Section:String;Data:string;Default:Double);
var
     w,x,y:integer;
begin
x:=findSection(section);
if x=-1 then
  begin
  items.add('['+section+']');
  items.add('');
  update;
  //x:=FindSection(section);
  end;
w:=FindBottom(section);
y:=finddata(section,data);
if y=-1 then
  if w-1 < Items.count-1 then
  begin
  Items.insert(w,data+'='+floattostr(default));
    Refresh;
  end

  else
  begin
  Items.Add(data+'='+floattostr(default));
    Refresh;
  end

else
  begin
  Items[y]:=data+'='+floattostr(default);
  Refresh;
  end


end;

{ Puts a Integer in the INI List Box... }
procedure TINIlist.PutInteger (Section:String;Data:String;Default:Integer);
var
     w,x,y:integer;
begin
x:=findSection(section);
if x=-1 then
  begin
  items.add('['+section+']');
  items.add('');
  update;
  //x:=FindSection(section);
  end;
w:=FindBottom(section);
y:=finddata(section,data);
if y=-1 then
  if w-1 < Items.count-1 then
  Begin
  Items.insert(w,data+'='+inttostr(default));
  Refresh;
  end
  else
  Begin
  Items.add(data+'='+inttoStr(default));
  Refresh;
  end

else
  Begin
  Items[y]:=data+'='+inttostr(default);
  Refresh;
  end;
end;

{ Puts a String in the INI List Box... }
procedure TINIlist.PutString (Section:String;Data:string;Default:String);
var
     w,x,y:integer;
begin
x:=findSection(section);
if x=-1 then
  begin
  items.add('['+section+']');
  items.add('');
  update;
  //x:=FindSection(section);
  end;
w:=FindBottom(section);
y:=finddata(section,data);
if y=-1 then
  if w-1 < Items.count-1 then
  begin
  Items.insert(w,data+'='+default);
    Refresh;
  end
else
  begin
  Items.Add(data+'='+Default);
  Refresh;
  end
else
  begin
  Items[y]:=data+'='+default;
  Refresh;
  end;

end;

procedure TINIlist.ReadData;
     { Internal declarations for method }
     { type }
     { . . . }
     { var }
     { . . . }
begin
FData:= getString(Header,title,'');
end;

procedure TINIlist.WriteData(Data:String);
     { Internal declarations for method }
     { type }
     { . . . }
     { var }
     { . . . }
begin
PutString(Header,Title,data);
end;


end.
